#------------------------------------------------------------------------------
#    59bbs, bulletin board system for anonymous publisher.
#    Copyright (C) 2007 Kaga, Hiroaki
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#------------------------------------------------------------------------------

package APPLIB::Logger;

use strict;
use warnings;

use APPLIB::Conf;

# コンストラクタ
sub new {
	my $this = {};

	my $confobj = APPLIB::Conf->new();

	$this->{SYSTEMDIR} = $confobj->SystemDir();
	$this->{LOCK_EX} = $confobj->LockEx();
	$this->{LOCK_UN} = $confobj->LockUn();

	bless($this);
	return $this;
}

# ログを書き込む 第一引数に書き込む文字列が設定されている
sub write {
	my $this = shift;
	my $str = shift;
	my $lsec;
	my $lmin;
	my $lhour;
	my $lday;
	my $lmon;
	my $lyear;

	# 日時を取得
	($lsec,$lmin,$lhour,$lday,$lmon,$lyear) = localtime(time);
	$lyear += 1900;
	$lmon++;
	my $writedate = "$lyear/$lmon/$lday $lhour:$lmin:$lsec";

	# ログを書き込む（常に追記）
	my $logfile = "$this->{SYSTEMDIR}/59bbs.log";

	open(LOGFILE,">>$logfile");
	flock(LOGFILE, $this->{LOCK_EX});
	seek(LOGFILE, 0, 2);
	print LOGFILE "$writedate,$str\n";
	flock(LOGFILE, $this->{LOCK_UN});
	close(LOGFILE);

	# ファイルのパーミッションを変更
	chmod 0766, $logfile;

	return 1;
}

1;
# End of Logger.pm
