#------------------------------------------------------------------------------
#    59bbs, bulletin board system for anonymous publisher.
#    Copyright (C) 2007 Kaga, Hiroaki
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#------------------------------------------------------------------------------

package APPLIB::Message;

use strict;
use warnings;

# コンストラクタ
sub new {
	my $this = {};
	bless($this);
	return $this;
}

# ユーザー認証エラーメッセージを表示する
sub autherror {
	my $this = shift;
	$this->printmsg(4, "ログインされていません");
}

# メッセージを表示する
sub printmsg {
	my $this = shift;
	my $type = shift;	# 第一引数：メッセージ種別
	my $body = shift;	# 第二引数：メッセージ本文
	my $title;
	my $loginform = '';
	my $backbutton;

	$backbutton = <<"END_OF_FORM";
<a href="javascript:history.back();">戻る</a>
END_OF_FORM

	if ($type == 1) {
		$title = "警告";
	}
	elsif ($type == 2) {
		$title = "エラー";
	}
	elsif ($type == 3) {
		$title = "システムエラー";
	}
	elsif ($type == 4) {
		$title = "ユーザー認証エラー";
		$backbutton = '';
		$loginform = <<"END_OF_FORM";
<!-- ログインフォーム -->
<table border="0" width="730" cellpadding=3 cellspacing=0 bgcolor="silver">
<tr>
<form method=post action="search.cgi">
<input type="hidden" name="login" value="1">
<td align="left">
<b>ユーザーID：</b><br>
<input type=text size="40" name="userid" value=""><br>
<b>パスワード：</b><br>
<input type=password size="40" name="userpwd"><br>
<br>
<input type=submit value="ログイン"> <input type="button" value="キャンセル" onclick="history.back()">
</td>
</form>
</tr>
</table>
END_OF_FORM
	}
	else {
		$title = "通知"; # 0
		$backbutton = <<"END_OF_FORM";
<a href="view.cgi">トップページに戻る</a>
END_OF_FORM
	}

	my $html = <<"END_OF_HTML";
Content-Type: text/html

<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf-8">
<title>$title</title>
<LINK REL=STYLESHEET HREF="system.css" TYPE="TEXT/CSS">
</head>
<body>
<h1>$title</h1>
<table border="0" width="730" cellpadding=3 cellspacing=0 bgcolor="silver">
<tr><td>
<font size="+1"><strong>$body</strong></font><br>
<br>
$backbutton
</td></tr>
</table>
<br>
$loginform

</body>
</html>
END_OF_HTML

	print $html;

	exit;
}

1;
# End of Message.pm
