#------------------------------------------------------------------------------
#    59bbs, bulletin board system for anonymous publisher.
#    Copyright (C) 2007 Kaga, Hiroaki
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#------------------------------------------------------------------------------

package APPLIB::Notify;

use strict;
use warnings;

#use Jcode;

use APPLIB::Conf;
use APPLIB::String;

# コンストラクタ
sub new {
	my $this = {};

	my $conf = APPLIB::Conf->new();

	$this->{SENDMAILPATH} = $conf->SendmailPath();
	$this->{FROM} = $conf->FromAddress();

	$this->{SUBJECT} = '';
	$this->{TEXT} = '';

	bless($this);
	return $this;
}

# サブジェクト
sub subject {
	my $this = shift;
	if (@_) {
		$this->{SUBJECT} = shift;
	}
	return $this->{SUBJECT};
}

# 本文
sub text {
	my $this = shift;
	if (@_) {
		$this->{TEXT} = shift;
	}
	return $this->{TEXT};
}

# メールを送信する
sub send {
	my $this = shift;
	my @addrlist = @_;
	my $from = $this->{FROM};
	my $mailpath = $this->{SENDMAILPATH};
	my $body = $this->{TEXT};

	# subjectをMIME-Base64形式に変換
	my $strobj = APPLIB::String->new();
	my $subject = $strobj->mimeencode($this->{SUBJECT});

	foreach my $mailaddr (@addrlist) {

		my $temp = <<"End_of_Temp";
From: $from
To: $mailaddr
Subject: $subject
Mime-Version: 1.0
Content-Type: text/plain; charset=iso-2022-jp
Content-Transfer-Encoding: 7bit

$body

End_of_Temp

		# メールを送信する
		open(SENDMAIL,"| $mailpath -t -oi $mailaddr");

		# 文字コードをJISに変換
		$temp = $strobj->encodeex('utf8', 'jis', $temp);

		print SENDMAIL $temp;
		close(SENDMAIL);
	}

	return 1;
}

1;
# End of Notify.pm
