#!/usr/bin/perl
#------------------------------------------------------------------------------
#    59bbs, bulletin board system for anonymous publisher.
#    Copyright (C) 2007,2008 Kaga, Hiroaki
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#------------------------------------------------------------------------------

use strict;
use warnings;

use CGI;

use APPLIB::Session;
use APPLIB::Message;
use APPLIB::Topic;
use APPLIB::Logger;

my $query = CGI->new();
my $msgobj = APPLIB::Message->new();

#my $loggerobj = APPLIB::Logger->new();

# クッキーからセッションIDを取得
my $sessionid = $query->cookie('cookie59b');
if ($sessionid eq '') {	# クッキー情報がない場合はログインされてない
	$msgobj->autherror();
}

my $sessionobj = APPLIB::Session->new();

# 有効なセッションかチェック
my $userid = $sessionobj->check($sessionid);
if (!$userid) {
	$msgobj->autherror();
}

# ユーザー種別の取得
my $usertype = $sessionobj->usertype($userid);

# トピックID
my $topicid = $query->param('topicid');
if ($topicid eq '') {
	$msgobj->printmsg(2, 'パラメータに誤りがあります');
}

my $topicobj = APPLIB::Topic->new();
$topicobj->mode(0);					# 動的生成モード（HTMLファイルは作成しない）
$topicobj->usertype($usertype);		# ユーザー種別を設定（動的生成モードの場合は必ず設定）
$topicobj->userid($userid);			# ユーザーIDを設定（同上）
$topicobj->load($topicid);			# トピックデータを読み込む
my $html = $topicobj->genhtml();	# トピックHTMLを生成

my $login ="<a href=\"logout.cgi\">ログアウト</a>";
$html =~ s/\$LOGIN\$/$login/g;

# トピック画面を表示
print "Content-Type: text/html\n\n";
print $html;

exit;
