#!/usr/bin/perl
#------------------------------------------------------------------------------
#    59bbs, bulletin board system for anonymous publisher.
#    Copyright (C) 2007,2008 Kaga, Hiroaki
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#------------------------------------------------------------------------------

use strict;
use warnings;

use CGI;
use APPLIB::Session;
use APPLIB::Message;
use APPLIB::User;
use APPLIB::Conf;

my $confobj = APPLIB::Conf->new();

my $query = CGI->new();
my $msgobj = APPLIB::Message->new();

# クッキーからセッションIDを取得
my $sessionid = $query->cookie('cookie59b');
if ($sessionid eq '') {	# クッキー情報がない場合はログインされてない
	$msgobj->autherror();
}

my $sessionobj = APPLIB::Session->new();

# 有効なセッションかチェック
my $userid = $sessionobj->check($sessionid);
if (!$userid) {
	$msgobj->autherror();
}

# 動作コード
my $opecode = $query->param('opecode');
if ($opecode eq '') {
	$msgobj->printmsg(2, 'パラメータに誤りがあります');
}

my $operation = '';
if ($opecode == 1) { # パスワード変更画面表示
	$operation = 'パスワード変更';
}
elsif ($opecode == 11) { # データ更新

	# パスワード
	my $password = $query->param('password');
	if ($password eq "") {
		$msgobj->printmsg(2, 'パスワードが未入力です');
	}
	# 確認のためのパスワード
	my $password2 = $query->param('password2');
	if ($password2 eq "") {
		$msgobj->printmsg(2, '確認のためのパスワードが未入力です');
	}
	if ($password ne $password2) {
		$msgobj->printmsg(2, '確認のために入力されたパスワードと一致していません');
	}
	# パスワードの長さをチェック
	if (length($password) < 4 || length($password) > 9) {
		$msgobj->printmsg(2, 'パスワードは半角英数字4文字～9文字で入力してください');
	}
	# パスワードが英数字かチェック
	if ($password =~ /[^0-9a-zA-Z]/) {
		$msgobj->printmsg(2, 'パスワードは半角英数字で入力してください');
	}

	updatepassword($userid, $password);	# データ更新処理
}
else {
	$msgobj->printmsg(2, 'パラメータに誤りがあります');
}

$opecode += 10;

my $program = "password.cgi";
my $systemdir = $confobj->SystemDir();

# 画面HTMLの生成
open(TEMPLATE, "$systemdir/password.htmlt");
local($/) = undef;
my $template = <TEMPLATE>;
close(TEMPLATE);

$template =~ s/\$OPERATION\$/$operation/g;
$template =~ s/\$PROGRAM\$/$program/g;
$template =~ s/\$OPECODE\$/$opecode/g;

my $temphtml =  <<"End_of_Temp";
Content-Type: text/html

$template
End_of_Temp

# パスワード変更画面を表示
print $temphtml;

exit;

sub updatepassword{
	my $userid = shift;
	my $password = shift;

	my $userobj = APPLIB::User->new();

	$userobj->load($userid);
	$userobj->password($password);
	$userobj->update();

	print "Location: search.cgi", "\n\n";

	exit;
}
