#!/usr/bin/perl
#------------------------------------------------------------------------------
#    59bbs, bulletin board system for anonymous publisher.
#    Copyright (C) 2007 Kaga, Hiroaki
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#------------------------------------------------------------------------------

use strict;
use warnings;

use CGI;
use APPLIB::Message;
use APPLIB::Session;
use APPLIB::View;

my $query = CGI->new();
my $msgobj = APPLIB::Message->new();
my $sessionobj = APPLIB::Session->new();
my $viewobj = APPLIB::View->new();

my $logined = 0;
# クッキーからセッションIDを取得
my $sessionid = $query->cookie('cookie59b');
if ($sessionid ne '') {
	# 有効なセッションかチェック
	my $userid = $sessionobj->check($sessionid);
	if ($userid) {
		$logined = 1;
	}
}
my $newpost = "<a href=\"newtopic.cgi\">新規投稿</a>";
my $login ="<a href=\"login.cgi\">ログイン</a>";
if ($logined) {
	$newpost ="<a href=\"topic.cgi?opcode=1\">新規投稿</a>";
	$login ="<a href=\"logout.cgi\">ログアウト</a>";
}

my $year = $query->param('year');	# 年
my $month = $query->param('month');	# 月
my $day = $query->param('day');		# 日

my $format = 0;
if ($year ne '' && $month ne '') {
	my $date = '';
	if ($day ne '') {
		$format = 2;
		$date = "$year/$month/$day";
	}
	else {
		$format = 1;
		$date = "$year/$month/01";
	}
	$viewobj->date($date);
}

$viewobj->format($format);
my $html = $viewobj->genhtml();	# HTMLを生成
$html =~ s/\$NEWPOST\$/$newpost/g;
$html =~ s/\$LOGIN\$/$login/g;

print "Content-Type: text/html\n\n";
print $html;

exit;
